/*********************************************************
 * DonutProtectionDevice  -  Genral use proximity detection   whmp 2014 4 06 
 * 
 * Run the  sketch and open the serial monitor 9600 return on.
 * Touch information is output on the serial port and an Audio sample is played
 * when the detect level is reached.
 *
 * Audio  is output on pin PWM 4.
 *
 *                      MrE@telus.net 
 **********************************************************/
#include <avr/pgmspace.h>
#include "SAFTD.h"

int sensitivity=12,detect=5,setuptouch=6000, warmup=500,warmwait;

#define numberofadc 8  
#define ADC_START (_BV(ADEN)|_BV(ADPS1)|_BV(ADPS2)|_BV(ADPS0)|_BV(ADSC)) // enable+ set clock+ start
#define ADC_11V (_BV(REFS0)|_BV(REFS1) )// internal 1.1 v ref

// for audio
volatile const prog_char * audiodata,*audiocurrent; 
volatile int audiorepeat;
#define AUDIOPORTDDR   DDRG
#define AUDIOPIN 5  // audio OC0B

int  analogindex,minval[numberofadc],maxval[numberofadc],val[numberofadc],wideval[numberofadc],baseval[numberofadc],diffval[numberofadc]; 

ISR(TIMER2_COMPA_vect) {
  //play audio
  if(audiocurrent){ // 
    OCR0B=pgm_read_byte(audiocurrent++);  // set pulse width
    if(!pgm_read_byte(audiocurrent)){      // is this the end of waveform?
      if(!(--audiorepeat)){        // repeat wave form?
        audiocurrent=0;  // stop
      }
      else{
        audiocurrent=audiodata;
        if(audiorepeat==-1)    audiorepeat=0;
      }
    }
  }
}
void soundsample(const prog_char * data, int repeat){
  while(audiocurrent)delay(1);
  audiodata=data;
  audiorepeat=repeat;
  audiocurrent=data;
};
void audiosetup(){
  cli();
  AUDIOPORTDDR=_BV(AUDIOPIN); // audio output pin as output
  TCCR2A = 0;
  TIMSK0=0;
  TIMSK1=0;
  TIMSK2=0;
  audiodata=0;
  OCR2A = 128;
  TCCR2A = _BV(WGM21);
  TIMSK2 = _BV(OCIE2A)+_BV(TOIE2);
  TCCR2B =  _BV(CS21); // clocks/8, start timmer
  TCCR0A= _BV(WGM00) | _BV(WGM01)| _BV(COM0A1) | _BV(COM0B1) ; // clear on match better to charge extra then discharge on missed update update 
  TCCR0B=_BV(CS00);// count sys clocks, start timmer
  sei();
}
void setup() { 
  int a; 
  audiosetup();
  for (a=0;a<numberofadc;a++)minval[a]=1024;// we calibrate down to detect minimums
  Serial.begin(9600); 
  Serial.println("warming up");
} 

void loop() { 
  char chin; // character in
  if((chin=Serial.read())>0){  // check for character
    if(chin>='a'&&chin<='z') sensitivity=chin-'a'+1;  //change touch sensitivity
    if(chin>='1'&&chin<='9') detect=chin-'0';  //change detect trigger count
    if(chin==13)showlevels(); // display current values
  }
  touchbar();  // test  and report touches
} 

void touchbar(){ // read adc's and store value,  analize after eacg set of reads 
  int v;
  if(ADCSRA&_BV(ADSC)){ 
    return;
  }// conversion not complete 
  v=ADCL; // read previous conversion results
  v+=ADCH<<8;

  //  Serial.println(v);
  DDRC=_BV(analogindex); //set as output to clear residual charge 
  PORTC=0; //and ground 
  DDRC=0;  // and back to input

  if(analogindex==8){
    // if(analogindex==numberofadc){ // change to this and you may need to ajust timming ... 
    testtouch();  // time to examine data 
    analogindex=0; //next read analog 0
  }
  else{ // time to read an adc
    if(analogindex<numberofadc)  val[analogindex]=v; // store value
    analogindex++;  // next adc
  }
  ADMUX=ADC_11V|(analogindex); // read against 1.1 volt reference
  ADCSRA=ADC_START; // start next conversion
}

unsigned char testtouch(){ //  process a set of ADC data
  unsigned char a,count=0,level=1;
  if(warmwait){ // let things stabilise a bit
    warmwait--;
     return(0);
  }
if(warmup){ // let things stabilise a bit after reset
    warmup--;
    if(!warmup) Serial.println("Calibrating"); // only happens once
    return(0);
  }
  if(setuptouch){  // find background levels
    for (a=0;a<numberofadc;a++){ 
      if(!a)  setuptouch--; // count complete adc  sets
      if(val[a]>maxval[a])maxval[a]=val[a];  // new max?
      if(val[a]<minval[a])minval[a]=val[a];  // new min?
      baseval[a]=(minval[a]+maxval[a])/2;   //baseline average reading
      wideval[a]=maxval[a]-minval[a];       // bandwidth
    }
    if(!setuptouch) showlevels(); // only happens once.
  }
  else{  // process last values and print out
    for (a=0;a<numberofadc;a++){ 
      if((diffval[a]=val[a]-baseval[a])<0)diffval[a]*=-1; // absolute dif frome baseline 
      if(diffval[a]>(wideval[a]*10)/sensitivity) // sensitivity calulation
      {
        level++;
        count++;  // are we showing touch 
        Serial.write(a+'0');

        if(diffval[a]>(wideval[a]*15)/sensitivity) {
          level++;
          Serial.write(a+'0'); 
        }
        if(diffval[a]>(wideval[a]*20)/sensitivity) {
          level++; 
          Serial.write(a+'0');
        }
        if(diffval[a]>(wideval[a]*25)/sensitivity){
          level++; 
          Serial.write(a+'0');
        }
      }
    }
  }
  if(count){
    if(count>=detect){
      Serial.print("  *");
      soundsample(StepAway,1); 
 snddelay(1);
warmwait=500;
}
    Serial.println();
  }
  return(count); // how many pins active
}

void showlevels(){
  int a;
  for (a=0;a<numberofadc;a++){ 
    Serial.write(a+'0');
    Serial.print(": max "); 
    Serial.print(maxval[a]); 
    Serial.print(": min "); 
    Serial.print(minval[a]); 
    Serial.print(": base "); 
    Serial.print(baseval[a]); 
    Serial.print(" background "); 
    Serial.print(wideval[a]/2); //normal variation from base
    Serial.print(" trigger "); 
    Serial.println((wideval[a]*10)/sensitivity); // trigger level
  }
    Serial.println("a - t sensitivity 1 - 9 Detect level");
 Serial.print("Sensitivity "); 
  Serial.write(sensitivity-1+'a'); 
  Serial.print(sensitivity); 
  Serial.print(" Detect "); 
  Serial.println(detect); 
}
void snddelay(unsigned char a){ // silence is a 62.5 khz square wave !
  soundsample(silent,100*a);
}


