/*********************************************************
 * SayNumber - Arduino Speech    whmp 2013 4 06 
 * 
 * Run the SayNumber sketch and open the serial monitor 9600 return on.
 * enter a number between 0 and 99 to hear it spoken.
 * Audio  is output on pin PWM 4.
 *
 *                      MrE@telus.net 
 **********************************************************/

#include <avr/pgmspace.h>
#include "Ambrosia.h"


#define AUDIOPORTDDR   DDRD
#define AUDIOPIN 5  // audio OC0B pin PWM 5

// for audio
volatile const prog_char * audiodata,*audiocurrent; 
volatile int audiorepeat,ticks;

ISR(TIMER2_COMPA_vect) {
   if(audiocurrent&&(ticks++&1))  { 
    OCR0B=pgm_read_byte(audiocurrent++);  // set pulse width
    if(!pgm_read_byte(audiocurrent)){      // is this the end of waveform?
      if(!(--audiorepeat)){        // repeat wave form?
        audiocurrent=0;  // stop
      }
      else{
        audiocurrent=audiodata;
        if(audiorepeat==-1)    audiorepeat=0;
      }
    }
  }
}
void soundsample(const prog_char * data, int repeat){
  while(audiocurrent)delay(1);
  audiodata=data;
  audiorepeat=repeat;
  audiocurrent=data;
};
void setup() { // only called once to initialize system
  cli();
  AUDIOPORTDDR=_BV(AUDIOPIN); // audio output pin as output
  TCCR2A = 0; //off
  TIMSK0=0;
  TIMSK1=0;
  TIMSK2=0;
  audiodata=0; 
  OCR2A = 127; 
  TCCR2A = _BV(WGM21); //count to cmpA
  TIMSK2 = _BV(OCIE2A); //interupt at cmpA
  TCCR2B =  _BV(CS21); // clocks/8, start timmer
  TCCR0A= _BV(WGM00) | _BV(WGM01)| _BV(COM0A1) | _BV(COM0B1) ; // clear on match better to charge extra then discharge on missed update update 
  TCCR0B=_BV(CS00);// count sys clocks, start timmer
  sei();
  Serial.begin(9600); 
} 
void loop(){
  char chin;
  int t=0;
  Serial.println("Enter number 0 - 99");
  while(1){
    if((chin=Serial.read())>0){  // check for character
      if(chin>='0'&&chin<='9') t=((t*10)+chin-'0')%100;  //0-99
      if(chin==13) {  
        say(t); 
        t=0;
      }
    }
  }
}
void say(char num){ // say a number between 0 and 99 by sequencing sound samples
  switch(num){
  case  0:
    soundsample(oh,1);
    break;
  case  1:
    soundsample(one,1);
    break;
  case  2:
    soundsample(two,1); 
    break;
  case  3:
    soundsample(three,1); 
    break;
  case  4:
    soundsample(four,1); 
    break;
  case  5:
    soundsample(five,1); 
    break;
  case  6:
    soundsample(six,1); 
    break;
  case  7:
    soundsample(seven,1); 
    break;
  case  8:
    soundsample(eight,1); 
    break;
  case  9:
    soundsample(nine,1); 
    break;
  case  10:
    soundsample(ten,1); 
    break;
  case  11:
    soundsample(eleven,1); 
    break;
  case  12:
    soundsample(twelve,1); 
    break;
  case  13:
  case  15:
  case  14:
  case  16:
  case  17:
  case  18:
  case  19:
    if(num==13)   soundsample(thir,1); 
    else if(num==15)    soundsample(fif,1); 
    else say(num%10);
    snddelay(5);
    soundsample(teen,1); 
    break;
  case  20:
  case  21:
  case  22:
  case  23:
  case  24:
  case  25:
  case  26:
  case  27:
  case  28:
  case  29:
    soundsample(twen,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==20) break;
    snddelay(10);
    say(num%10);
    break;
  case  30:
  case  31:
  case  32:
  case  33:
  case  34:
  case  35:
  case  36:
  case  37:
  case  38:
  case  39:
    soundsample(thir,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==30) break;
    snddelay(10);
    say(num%10);
    break;
  case  40:
  case  41:
  case  42:
  case  43:
  case  44:
  case  45:
  case  46:
  case  47:
  case  48:
  case  49:
    soundsample(four,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==40) break;
    snddelay(10);
    say(num%10);
    break;
  case  50:
  case  51:
  case  52:
  case  53:
  case  54:
  case  55:
  case  56:
  case  57:
  case  58:
  case  59:
    soundsample(fif,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==50) break;
    snddelay(10);
    say(num%10);
    break;

  case  60:
  case  61:
  case  62:
  case  63:
  case  64:
  case  65:
  case  66:
  case  67:
  case  68:
  case  69:
    soundsample(six,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==60) break;
    snddelay(10);
    say(num%10);
    break;
  case  70:
  case  71:
  case  72:
  case  73:
  case  74:
  case  75:
  case  76:
  case  77:
  case  78:
  case  79:
    soundsample(seven,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==70) break;
    snddelay(10);
    say(num%10);
    break;
  case  80:
  case  81:
  case  82:
  case  83:
  case  84:
  case  85:
  case  86:
  case  87:
  case  88:
  case  89:
    soundsample(eight,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==80) break;
    snddelay(10);
    say(num%10);
    break;
  case  90:
  case  91:
  case  92:
  case  93:
  case  94:
  case  95:
  case  96:
  case  97:
  case  98:
  case  99:
    soundsample(nine,1); 
    snddelay(5);
    soundsample(tee,1); 
    if(num==90) break;
    snddelay(10);
    say(num%10);
    break;
  }
}

void snddelay(unsigned char a){ // silence is a 50% duty cycle 62.5 khz square wave !
  soundsample(silent,100*a);
}



